image: python:3.10-alpine

stages:
  - build
  - deploy

before_script:
  - pip install -r requirements.txt --upgrade


build:
  stage: build
  script:
    - pip install build
    - pip install -r requirements.txt
    - source mktoml.sh
    - python -m build
  artifacts:
    paths:
    - dist
  rules:
    - if: $CI_COMMIT_TAG =~ /\A[0-9]+.[0-9]+.[0-9]+(.*|dev[0-9]*)\z/

upload:
  stage: deploy
  script:
    - pip install twine
    - TWINE_PASSWORD=${CI_JOB_TOKEN} TWINE_USERNAME=gitlab-ci-token 
          python -m twine upload --repository-url ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/pypi dist/*
  rules:
    - if: $CI_COMMIT_TAG =~ /\A[0-9]+.[0-9]+.[0-9]+(.*|dev[0-9]*)\z/


pages:
  stage: deploy
  script:
    - pip install mkdocs mkdocstrings mkdocstrings-python
    - export ENABLE_MKDOCS_PDF=0
    - mkdocs build --verbose
    - mv site public
  artifacts:
    paths:
    - public
  rules:
    - if: $CI_COMMIT_TAG =~ /\A[0-9]+.[0-9]+.[0-9]+(.*|dev[0-9]*)\z/
